﻿;==========================================================================================================================
; Export keyboard shortcuts to pb include file
;==========================================================================================================================

Procedure ExportShortCutsToCode()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Program\WindowName <> "" And Program\ProjectName <> ""
    
    ;----------------------------------------------------------------------------------------------
    ; Count the number of shortcuts in the list to be processed
    ;----------------------------------------------------------------------------------------------
    
    NumShortCuts.i = CountGadgetItems(#Gadget_ShortCutter_keylist)
    
    ;----------------------------------------------------------------------------------------------
    ; Only execute the following code if we have any shortcuts to be processed
    ;----------------------------------------------------------------------------------------------
    
    If NumShortCuts.i
      
      ;--------------------------------------------------------------------------------------------
      ; Clear the existing list of shortcuts to be processed
      ;--------------------------------------------------------------------------------------------
      
      ClearList(Keys.s())
      
      ;--------------------------------------------------------------------------------------------
      ; Grab all the shortcuts into a linked list for repeat processing. No need to do more than once.
      ; We grab all the headings as well.
      ;--------------------------------------------------------------------------------------------
      
      For ShortCutGrab.i = 0 To NumShortCuts.i - 1
        
        AddElement(Keys.s())
        
        Keys()\KeyDataName    = GetGadgetItemText(#Gadget_ShortCutter_keylist, ShortCutGrab.i, 0) ; The variable name with spaces
        
        Keys()\KeyDataText    = ReplaceString(Keys()\KeyDataName, " " , "", 1, 1)                 ; The variable name with spaces as menu text
        
        Keys()\KeyDataValue   = GetGadgetItemText(#Gadget_ShortCutter_keylist, ShortCutGrab.i, 1) ; The PB key value of the text shortcut key
        
        Keys()\KeyDataKeys    = GetGadgetItemText(#Gadget_ShortCutter_keylist, ShortCutGrab.i, 2) ; The text representation of the shortcut 
        
        Keys()\KeyDataBalloon = GetGadgetItemText(#Gadget_ShortCutter_keylist, ShortCutGrab.i, 3) ; The shortcut full text as used in balloon tooltips
        
        Keys()\KeyDataicon    = GetGadgetItemText(#Gadget_ShortCutter_keylist, ShortCutGrab.i, 4) ; The icon for the menubar if any
        
      Next
      
      ;--------------------------------------------------------------------------------------------
      ; Write out all the various file sections and individual files
      ;--------------------------------------------------------------------------------------------
      
      CreateEmptyProcedures()                                                                       ; 
      
      LoadkeyboardShortCutsFile()                                                                   ; 
      
      MainMenuFile()                                                                                ; 
      
      MainProgramFile()                                                                             ; 
      
      MakeSureDirectoryPathExistsFile()                                                             ; 
      
      MyBalloonToolTipsFile()                                                                       ; 
      
      MyConstantsFile()                                                                             ; 
      
      MyDeclarationsFile()                                                                          ; 
      
      OpenSystemDatabaseFile()                                                                      ; 
      
      SelectWindowToolTipsFile()                                                                    ; 
      
      SetGadgetText(#Gadget_ShortCutter_messages, "Exporting of all code to target program is finished")
                    
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetGadgetText(#Gadget_ShortCutter_messages, "No shortcuts in list to save.")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetGadgetText(#Gadget_ShortCutter_messages, "Window name and target program name are not available.")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.11 (Windows - x86)
; CursorPosition = 66
; FirstLine = 66
; Folding = -
; EnableXP
; HideErrorLog