﻿;========================================================================================================================================
; Create the balloon tooltips handler
;========================================================================================================================================

Procedure MyBalloonToolTipsFile()
  
  ;----------------------------------------------------------------------------------------------
  ; Proceed if there is a predefined project directory
  ;----------------------------------------------------------------------------------------------
  
  OutputFileName.s = Program\ModuleDirectory + "_MyBalloonToolTips.pbi"
  
  ;----------------------------------------------------------------------------------------------
  ; 
  ;----------------------------------------------------------------------------------------------
  
  If OutputFileName.s
    
    ;--------------------------------------------------------------------------------------------
    ; Create the output file to save to
    ;--------------------------------------------------------------------------------------------
    
    OutputFileHandle.i = CreateFile(#PB_Any, OutputFileName.s)
    
    ;--------------------------------------------------------------------------------------------
    ; 
    ;--------------------------------------------------------------------------------------------
    
    If OutputFileHandle.i
      
      ;******************************************************************************************
      ; Create the balloon tooltips tracking procedure
      ;******************************************************************************************
      
      WriteHeadingToOutputFile(OutputFileHandle.i, "; Personal balloon tooltip window, colourful and not boring at all")

      WriteStringN(OutputFileHandle.i, "Procedure MyBalloonToolTips(btWindow.i, btGadget.i, btText.s)")
      
      WriteStringN(OutputFileHandle.i,     "")
            
      WriteStringN(OutputFileHandle.i, "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i, "  ; ")
      
      WriteStringN(OutputFileHandle.i, "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  ForEach ToolTips()")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "    If ToolTips()\Window = btWindow And ToolTips()\Gadget = btGadget")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "      ProcedureReturn")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "    EndIf")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  Next")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i, "  ; ")
      
      WriteStringN(OutputFileHandle.i, "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  ToolTipControl = CreateWindowEx_(0, " + Chr(34) + "ToolTips_Class32" + Chr(34) + ", " + Chr(34) + Chr(34) + ", #WS_POPUP | #TTS_NOPREFIX | #TTS_BALLOON, 0, 0, 0, 0, WindowID(btWindow), 0, GetModuleHandle_(0), 0)")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i, "  ; ")
      
      WriteStringN(OutputFileHandle.i, "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  SetWindowPos_(ToolTipControl, #HWND_TOPMOST, 0, 0, 0, 0, #SWP_NOMOVE | #SWP_NOSIZE)")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  SendMessage_(ToolTipControl,  #TTM_SETTIPTEXTCOLOR, 0, 0)")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  SendMessage_(ToolTipControl,  #TTM_SETTIPBKCOLOR, $F58C0A, 0)")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  SendMessage_(ToolTipControl,  #TTM_SETMAXTIPWIDTH, 0, 290)")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i, "  ; ")
      
      WriteStringN(OutputFileHandle.i, "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  Button.TOOLINFO\cbSize  = SizeOf(TOOLINFO)")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  Button\uFlags           = #TTF_IDISHWND | #TTF_SUBCLASS")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  Button\hwnd             = WindowID(btWindow)")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  Button\uID              = GadgetID(btGadget)")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  Button\hInst            = 0")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  Button\lpszText         = @btText")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i, "  ; ")
      
      WriteStringN(OutputFileHandle.i, "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  SendMessage_(ToolTipControl, #TTM_ADDTOOL, 0, Button)")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  SendMessage_(ToolTipControl, #TTM_UPDATE, 0, 0)")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i, "  ; ")
      
      WriteStringN(OutputFileHandle.i, "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  AddElement(tooltips())")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "    ToolTips()\Window = btWindow")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "    ToolTips()\Gadget = btGadget")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "    ToolTips()\Handle = ToolTipControl")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i, "  ; ")
      
      WriteStringN(OutputFileHandle.i, "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "EndProcedure")
      
      ;------------------------------------------------------------------------------------------
      ; Close the output file as we are finished writing to it
      ;------------------------------------------------------------------------------------------
      
      CloseFile(OutputFileHandle.i)
      
      ;------------------------------------------------------------------------------------------
      ; 
      ;------------------------------------------------------------------------------------------
      
    Else
      
      SetGadgetText(#Gadget_ShortCutter_messages, Str(OutputFileHandle.i) + " could not be created.")
      
    EndIf
    
    ;--------------------------------------------------------------------------------------------
    ; 
    ;--------------------------------------------------------------------------------------------
      
  Else
    
    SetGadgetText(#Gadget_ShortCutter_messages, OutputFileName.s + " does not exist.")
    
  EndIf
  
  ;----------------------------------------------------------------------------------------------
  ; 
  ;----------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.11 (Windows - x86)
; CursorPosition = 208
; FirstLine = 180
; Folding = -
; EnableXP