﻿;========================================================================================================================================
; Create the declaration include file
;========================================================================================================================================

Procedure MyDeclarationsFile()
  
  ;----------------------------------------------------------------------------------------------
  ; Proceed if there is a predefined project directory
  ;----------------------------------------------------------------------------------------------
  
  OutputFileName.s = Program\ProjectDirectory + Program\ProjectName + "_MyDeclarations.pb"
  
  ;----------------------------------------------------------------------------------------------
  ; 
  ;----------------------------------------------------------------------------------------------
  
  If OutputFileName.s
    
    ;--------------------------------------------------------------------------------------------
    ; Create the output file to save to
    ;--------------------------------------------------------------------------------------------
    
    OutputFileHandle.i = CreateFile(#PB_Any, OutputFileName.s)
    
    ;--------------------------------------------------------------------------------------------
    ; 
    ;--------------------------------------------------------------------------------------------
    
    If OutputFileHandle.i
      
      ;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      ; Create the procedural declaration for the database table
      ;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      
      WriteHeadingToOutputFile(OutputFileHandle.i, "; Keyboard shortcuts program procedural declaration")
      
      WriteStringN(OutputFileHandle.i,            FormatField("DECLARE OpenSystemDatabase()", 93) + "; ")
      
      WriteStringN(OutputFileHandle.i,            FormatField("DECLARE LoadkeyboardShortCuts()", 93) + "; ")
      
      WriteStringN(OutputFileHandle.i,            FormatField("DECLARE CreateMainMenu()", 93) + "; ")
      
      WriteStringN(OutputFileHandle.i,            FormatField("DECLARE MakeSureDirectoryPathExists(Directory.s)", 93) + "; ")
      
      WriteStringN(OutputFileHandle.i,            FormatField("DECLARE MyBalloonToolTips(btWindow.i, btGadget.i, btText.s)", 93) + "; ")
      
      WriteStringN(OutputFileHandle.i,            FormatField("DECLARE SelectWindowToolTips(Window.i)", 93) + "; ")
      
      ;------------------------------------------------------------------------------------------
      ; All the modules belonging to the 'Files' menu
      ;------------------------------------------------------------------------------------------
      
      ForEach Keys.s()
        
        If Left(Keys()\KeyDataName, 1) = "~" And Right(Keys()\KeyDataName, 1) = "~"
          
          WriteStringN(OutputFileHandle.i,  "")
          
          WriteStringN(OutputFileHandle.i,  ";==========================================================================================================================")
          
          WriteStringN(OutputFileHandle.i,  "; " + RemoveString(Keys()\KeyDataText, "~", 1, 1) + " menu procedure declarations")
          
          MakeSureDirectoryPathExists(Program\ModuleDirectory + RemoveString(Keys()\KeyDataName, "~", 1, 1))
          
          WriteStringN(OutputFileHandle.i,  ";==========================================================================================================================")
          
          WriteStringN(OutputFileHandle.i,  "")
          
        Else
          
          WriteStringN(OutputFileHandle.i,  FormatField("DECLARE " + Keys()\KeyDataText + "()", 93) + "; ")
          
        EndIf
        
      Next
      
      ;------------------------------------------------------------------------------------------
      ; Close the output file as we are finished writing to it
      ;------------------------------------------------------------------------------------------
      
      CloseFile(OutputFileHandle.i)
      
      ;------------------------------------------------------------------------------------------
      ; 
      ;------------------------------------------------------------------------------------------
      
    Else
      
      SetGadgetText(#Gadget_ShortCutter_messages, Str(OutputFileHandle.i) + " could not be created.")
      
    EndIf
    
    ;--------------------------------------------------------------------------------------------
    ; 
    ;--------------------------------------------------------------------------------------------
      
  Else
    
    SetGadgetText(#Gadget_ShortCutter_messages, OutputFileName.s + " does not exist.")
    
  EndIf
  
  ;----------------------------------------------------------------------------------------------
  ; 
  ;----------------------------------------------------------------------------------------------
    
EndProcedure

; IDE Options = PureBasic 5.11 (Windows - x86)
; CursorPosition = 34
; FirstLine = 31
; Folding = -
; EnableXP