;============================================================================================================================
; Standard constants, windows code etc
;============================================================================================================================

XIncludeFile "ShortCutter_Constants.pb"                                                 ; Visual designer ceated constants
XIncludeFile "ShortCutter_Windows.pb"                                                   ; Visual designer ceated constants
XIncludeFile "ShortCutter_Mydeclarations.pb"                                            ; All procedural declarations
XIncludeFile "ShortCutter_Myconstants.pb"                                               ; All my personal constants

;==========================================================================================================================
; Generic modules as made almost entirely by others
;==========================================================================================================================

XIncludeFile "Modules\Generic\_FormatField.pbi"                                         ; Format the passed string to the correct field length for printing
XIncludeFile "Modules\Generic\_GetShortcutText.pbi"                                     ; Get the text of the associated shortcut constant
XIncludeFile "Modules\Generic\_ListIconGadgetMove.pbi"                                  ; Move lines around in a single ListIconGadget
XIncludeFile "Modules\Generic\_ListIconGadgetColumns.pbi"                               ; Count the number of columns in a ListIconGadget
XIncludeFile "Modules\Generic\_MakeSureDirectoryPathExists.pbi"                         ; Need a unicode aware version of the API directory creator
XIncludeFile "Modules\Generic\_MixedStringCase.pbi"                                     ; First letter uppercase in a string box. srod!

;==========================================================================================================================
; Custom modules by me
;==========================================================================================================================

XIncludeFile "Modules\Custom\_ClearShortCuts.pbi"                                       ; Clear all shortcuts from the list
XIncludeFile "Modules\Custom\_CloseMyWindow.pbi"                                        ; Custom window closer with variable cleanup
XIncludeFile "Modules\Custom\_CopyShortCutToList.pbi"                                   ; Copy the current shortcut to the key list
XIncludeFile "Modules\Custom\_CountShortCuts.pbi"                                       ; Count the number of shortcuts in the list. Excluding menu titles
XIncludeFile "Modules\Custom\_ExportShortCutsToCode.pbi"                                ; Export keyboard shortcuts to pb include file
XIncludeFile "Modules\Custom\_GetIconForShortCut.pbi"                                   ; Link an icon for the shortcut menu
XIncludeFile "Modules\Custom\_GetProjectDetails.pbi"                                    ; Get the window and program names to export for
XIncludeFile "Modules\Custom\_SaveProjectDetails.pbi"                                   ; Save the project window and program names for this session
XIncludeFile "Modules\Custom\_ShortCutToValue.pbi"                                      ; Copy shortcut value to edit form
XIncludeFile "Modules\Custom\_WriteHeadingToOutputFile.pbi"                             ; Shorten the heading creation for the output files/files

;==========================================================================================================================
; Shortcut data handling
;==========================================================================================================================

XIncludeFile "Modules\Data\_AddShortCut.pbi"                                            ; Add a new shortcut to the list
XIncludeFile "Modules\Data\_CopyShortCut.pbi"                                           ; Copy shortcut to the clipboard
XIncludeFile "Modules\Data\_DeleteShortCut.pbi"                                         ; Delete the currently selected shortcut
XIncludeFile "Modules\Data\_EditShortCut.pbi"                                           ; Edi the selected shortcut
XIncludeFile "Modules\Data\_SaveShortCut.pbi"                                           ; Save the new or changed shortcut

;==========================================================================================================================
; Shortcut menu heading handling
;==========================================================================================================================

XIncludeFile "Modules\Menu\_AddShortCutHeading.pbi"                                     ; Add a new shortcut menu heading
XIncludeFile "Modules\Menu\_DeleteShortCutHeading.pbi"                                  ; Delete the shortcut menu heading
XIncludeFile "Modules\Menu\_EditShortCutHeading.pbi"                                    ; Edit the shortcut menu heading
XIncludeFile "Modules\Menu\_SaveShortCutHeading.pbi"                                    ; Save the changed shortcut heading

;==========================================================================================================================
; Loading and saving keyboard shortcut sets
;==========================================================================================================================

XIncludeFile "Modules\Files\_LoadShortCutsFromDisk.pbi"                                 ; Load a shortcuts key list from disk
XIncludeFile "Modules\Files\_SaveShortCutsToDisk.pbi"                                   ; Save the shortcuts key list to disk

;==========================================================================================================================
; 
;==========================================================================================================================

XIncludeFile "Modules\Export\_CreateEmptyProcedures.pbi"                                 ; Create the empty procedures
XIncludeFile "Modules\Export\_LoadkeyboardShortCutsFile.pbi"                             ; Create the keyboard shortcuts loader
XIncludeFile "Modules\Export\_MainMenuFile.pbi"                                          ; Create the main program menu file
XIncludeFile "Modules\Export\_MainProgramFile.pbi"                                       ; Create the main program file
XIncludeFile "Modules\Export\_MakeSureDirectoryPathExistsFile.pbi"                       ; Create the directory creator procedure
XIncludeFile "Modules\Export\_MyBalloonToolTipsFile.pbi"                                 ; Create the balloon tooltips handler
XIncludeFile "Modules\Export\_MyConstantsFile.pbi"                                       ; Create the program constants file
XIncludeFile "Modules\Export\_MyDeclarationsFile.pbi"                                    ; Create the declaration include file
XIncludeFile "Modules\Export\_OpenSystemDatabaseFile.pbi"                                ; Create the system database procedure
XIncludeFile "Modules\Export\_SelectWindowToolTipsFile.pbi"                              ; Create the window tooltips selector

;==========================================================================================================================
; 
;==========================================================================================================================

If Window_ShortCutter()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  Program\DragItem = -1
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  Program\QuitValue = 0
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  Program\OldWindowTitle = GetWindowTitle(#Window_ShortCutter)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  EnableGadgetDrop(#Gadget_ShortCutter_keylist, #PB_Drop_Private, #PB_Drag_Move, 1)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  CountShortCuts()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SetWindowTitle(#Window_ShortCutter, Program\OldWindowTitle + ",  " + #Program + "  ready to work!.")
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  SetGadgetText(#Gadget_ShortCutter_messages, #Author + " Presents:  " + #Program + "  ready to work!.")
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  SetGadgetState(#Gadget_ShortCutter_copytolist, 1)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  SetActiveGadget(#Gadget_ShortCutter_current)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  Repeat
    Select WaitWindowEvent()
      Case #PB_Event_CloseWindow
        Select EventWindow()
          Case #Window_ShortCutter                          : Program\QuitValue = 1
          Case #Window_ShortCutEdit                         : CloseMyWindow(#Window_ShortCutEdit)
          Case #Window_ShortCutHeadingEdit                  : CloseMyWindow(#Window_ShortCutHeadingEdit)
          Case #Window_ShortCutProject                      : CloseMyWindow(#Window_ShortCutProject)
        EndSelect
        ;----------------------------------------------------
        ; Move the selected item in the list
        ;----------------------------------------------------
      Case #PB_Event_GadgetDrop 
        Select EventGadget()
          Case #Gadget_ShortCutter_keylist
            Select EventDropType()
              Case #PB_Drop_Private
                Select EventDropPrivate()
                  Case 1                                    : ListIconGadgetMove(#Gadget_ShortCutter_keylist, Program\DragItem, GetGadgetState(#Gadget_ShortCutter_keylist))
                EndSelect
            EndSelect
        EndSelect
        ;----------------------------------------------------
        ; Check for gadget events
        ;----------------------------------------------------
      Case #PB_Event_Gadget
        Select EventGadget()
          ;--------------------------------------------------
          ; Shortcut list events
          ;--------------------------------------------------
          Case #Gadget_ShortCutter_keylist
            Select EventType()
              Case #PB_EventType_LeftDoubleClick            : EditShortCut()
              Case #PB_EventType_RightDoubleClick           : AddShortCut()
              Case #PB_EventType_DragStart                  : Program\DragItem = GetGadgetState(#Gadget_ShortCutter_keylist) : DragPrivate(1, #PB_Drag_Move)
            EndSelect
            ;------------------------------------------------
            ; Main form events
            ;------------------------------------------------
          Case #Gadget_ShortCutter_load                     : LoadShortCutsFromDisk()
          Case #Gadget_ShortCutter_save                     : SaveShortCutsToDisk()
          Case #Gadget_ShortCutter_export                   : ExportShortCutsToCode()            
          Case #Gadget_ShortCutter_add                      : AddShortCut()
          Case #Gadget_ShortCutter_copy                     : CopyShortCut()
          Case #Gadget_ShortCutter_delete                   : DeleteShortCut()
          Case #Gadget_ShortCutter_edit                     : EditShortCut()
          Case #Gadget_ShortCutter_clear                    : ClearShortCuts()
          Case #Gadget_ShortCutter_project                  : GetProjectDetails()
          Case #Gadget_ShortCutter_exit                     : Program\QuitValue = 1
          Case #Gadget_ShortCutter_current                  : CopyShortcutToList()
          ;--------------------------------------------------
          ; Main form heading events
          ;--------------------------------------------------
          Case #Gadget_ShortCutter_addheading               : AddShortCutHeading()
          Case #Gadget_ShortCutter_deleteheading            : DeleteShortCutHeading()
          Case #Gadget_ShortCutter_editheading              : EditShortCutHeading()
          ;--------------------------------------------------
          ; Shortcut menu editor events
          ;--------------------------------------------------
          Case #Gadget_ShortCutEdit_keyboardvariable        : MixedStringCase(#Gadget_ShortCutEdit_keyboardvariable)
          Case #Gadget_ShortCutEdit_keyboardshortcut        : ShortCutToValue()
          Case #Gadget_ShortCutEdit_geticon                 : GetIconForShortCut()
          Case #Gadget_ShortCutEdit_save                    : SaveShortCut()
          Case #Gadget_ShortCutEdit_exit                    : CloseMyWindow(#Window_ShortCutEdit)
          ;--------------------------------------------------
          ; Menu heading editor events
          ;--------------------------------------------------
          Case #Gadget_ShortCutHeadingEdit_keyboardvariable : MixedStringCase(#Gadget_ShortCutHeadingEdit_keyboardvariable)
          Case #Gadget_ShortCutHeadingEdit_save             : SaveShortCutHeading()
          Case #Gadget_ShortCutHeadingEdit_exit             : CloseMyWindow(#Window_ShortCutHeadingEdit)
          ;--------------------------------------------------
          ; 
          ;--------------------------------------------------
          Case #Gadget_ShortCutProject_save                 : SaveProjectDetails()
          Case #Gadget_ShortCutProject_exit                 : CloseMyWindow(#Window_ShortCutProject)
          ;------------------------------------------------
          ; 
          ;------------------------------------------------
        EndSelect
        ;--------------------------------------------------
        ; 
        ;--------------------------------------------------
    EndSelect
    ;------------------------------------------------------
    ; 
    ;------------------------------------------------------
  Until Program\QuitValue
  ;--------------------------------------------------------
  ; 
  ;--------------------------------------------------------
  CloseWindow(#Window_ShortCutter)
  ;--------------------------------------------------------
  ; 
  ;--------------------------------------------------------
EndIf
;----------------------------------------------------------
; 
;----------------------------------------------------------
End

; IDE Options = PureBasic 5.11 (Windows - x86)
; CursorPosition = 65
; FirstLine = 51
; EnableXP
; UseIcon = ..\..\Dev-Resource\Images\General icons\16x16\quickkeys16x16.ico